# Its4landPublicApi.ModelClassesApi

All URIs are relative to *https://platform.its4land.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getModelClasses**](ModelClassesApi.md#getModelClasses) | **GET** /modelclasses | Returns ModelClasses
[**getModelClassesByUID**](ModelClassesApi.md#getModelClassesByUID) | **GET** /modelclasses/{modelclasses_uid} | Returns a single model class
[**updateModelClasses**](ModelClassesApi.md#updateModelClasses) | **PATCH** /modelclasses/{modelclasses_uid} | Updates some attributes of a ModelClass


<a name="getModelClasses"></a>
# **getModelClasses**
> [ModelClassesEndpointType] getModelClasses(opts, responseAsResult = *false*)

Returns ModelClasses

Returns ModelClasses

### Example
```javascript
var Its4landPublicApi = require('its4land_public_api');

var apiInstance = new Its4landPublicApi.ModelClassesApi();

var opts = { 
  'envelope': "envelope_example", // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
  'UID': ["UID_example"], // [String] | Comma separated list of ModelClasses UID
  'nameinmodel': ["nameinmodel_example"], // [String] | Comma separated list of ModelClasses names
  'conceptname': ["conceptname_example"], // [String] | Comma separated list of ModelClasses concept names
  'page': 56, // Number | Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
  'sort': "sort_example", // String | The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
  'fields': ["fields_example"] // [String] | Comma separated list of field names
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.getModelClasses(opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **UID** | [**[String]**](String.md)| Comma separated list of ModelClasses UID | [optional] 
 **nameinmodel** | [**[String]**](String.md)| Comma separated list of ModelClasses names | [optional] 
 **conceptname** | [**[String]**](String.md)| Comma separated list of ModelClasses concept names | [optional] 
 **page** | **Number**| Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. | [optional] 
 **sort** | **String**| The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. | [optional] 
 **fields** | [**[String]**](String.md)| Comma separated list of field names | [optional] 


### Return type

[**[ModelClassesEndpointType]**](ModelClassesEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getModelClassesByUID"></a>
# **getModelClassesByUID**
> ModelClassesEndpointType getModelClassesByUID(modelclassesUid, opts, responseAsResult = *false*)

Returns a single model class

Returns a single model class

### Example
```javascript
var Its4landPublicApi = require('its4land_public_api');

var apiInstance = new Its4landPublicApi.ModelClassesApi();

var modelclassesUid = "modelclassesUid_example"; // String | ModelClass UID

var opts = { 
  'envelope': "envelope_example", // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.getModelClassesByUID(modelclassesUid, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **modelclassesUid** | **String**| ModelClass UID | 
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 


### Return type

[**ModelClassesEndpointType**](ModelClassesEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="updateModelClasses"></a>
# **updateModelClasses**
> ModelClassesEndpointType updateModelClasses(modelclassesUid, patchmodelclasses, opts, responseAsResult = *false*)

Updates some attributes of a ModelClass

Updates some attributes of a ModelClass

### Example
```javascript
var Its4landPublicApi = require('its4land_public_api');

var apiInstance = new Its4landPublicApi.ModelClassesApi();

var modelclassesUid = "modelclassesUid_example"; // String | ModelClass UID

var patchmodelclasses = new Its4landPublicApi.RFC6902PatchRequest(); // RFC6902PatchRequest | Update data

var opts = { 
  'envelope': "envelope_example", // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
  'i4lProcessUid': "i4lProcessUid_example" // String | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.updateModelClasses(modelclassesUid, patchmodelclasses, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **modelclassesUid** | **String**| ModelClass UID | 
 **patchmodelclasses** | [**RFC6902PatchRequest**](RFC6902PatchRequest.md)| Update data | 
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **i4lProcessUid** | **String**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional] 


### Return type

[**ModelClassesEndpointType**](ModelClassesEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

