# Its4landPublicApi.SpatialSourcesApi

All URIs are relative to *https://platform.its4land.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**detachSpatialSourceAddDoc**](SpatialSourcesApi.md#detachSpatialSourceAddDoc) | **DELETE** /spatialsource/{spatialsource_uid}/AdditionalDocument/{adddoc_uid} | Removes an additional document for a spatial source.
[**getSpatialSourceAddDocs**](SpatialSourcesApi.md#getSpatialSourceAddDocs) | **GET** /spatialsource/{spatialsource_uid}/AdditionalDocument | Returns the additional documents of a spatial source
[**getSpatialSourceByUID**](SpatialSourcesApi.md#getSpatialSourceByUID) | **GET** /spatialsource/{spatialsource_uid} | Returns a single SpatialSource
[**getSpatialSourceSingleAddDoc**](SpatialSourcesApi.md#getSpatialSourceSingleAddDoc) | **GET** /spatialsource/{spatialsource_uid}/AdditionalDocument/{adddoc_uid} | Returns the additional documents of a spatial source
[**getSpatialSources**](SpatialSourcesApi.md#getSpatialSources) | **GET** /spatialsources | Returns a list of SpatialSources
[**newSpatialSource**](SpatialSourcesApi.md#newSpatialSource) | **POST** /spatialsources | Create a new SpatialSource
[**newSpatialSourceAddAddDoc**](SpatialSourcesApi.md#newSpatialSourceAddAddDoc) | **POST** /spatialsource/{spatialsource_uid}/AdditionalDocument | Add a new additional document to a spatial source
[**putSpatialSourceByUID**](SpatialSourcesApi.md#putSpatialSourceByUID) | **PUT** /spatialsource/{spatialsource_uid} | Replace an existing SpatialSource by a newer version


<a name="detachSpatialSourceAddDoc"></a>
# **detachSpatialSourceAddDoc**
> [SpatialSourcesEndpointType] detachSpatialSourceAddDoc(spatialsourceUid, adddocUid, opts, responseAsResult = *false*)

Removes an additional document for a spatial source.

Removes an additional document for a spatial source. By default only the link between additional document and spatial source is removed.

### Example
```javascript
var Its4landPublicApi = require('its4land_public_api');

var apiInstance = new Its4landPublicApi.SpatialSourcesApi();

var spatialsourceUid = "spatialsourceUid_example"; // String | SpatialSource UID

var adddocUid = "adddocUid_example"; // String | SpatialSource UID

var opts = { 
  'envelope': "envelope_example", // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
  'forceDelete': "forceDelete_example" // String | Deletes the additional document resource.
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.detachSpatialSourceAddDoc(spatialsourceUid, adddocUid, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **spatialsourceUid** | **String**| SpatialSource UID | 
 **adddocUid** | **String**| SpatialSource UID | 
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **forceDelete** | **String**| Deletes the additional document resource. | [optional] 


### Return type

[**[SpatialSourcesEndpointType]**](SpatialSourcesEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getSpatialSourceAddDocs"></a>
# **getSpatialSourceAddDocs**
> [AdditionalDocumentsEndpointType] getSpatialSourceAddDocs(spatialsourceUid, opts, responseAsResult = *false*)

Returns the additional documents of a spatial source

Returns the additional documents of a spatial source

### Example
```javascript
var Its4landPublicApi = require('its4land_public_api');

var apiInstance = new Its4landPublicApi.SpatialSourcesApi();

var spatialsourceUid = "spatialsourceUid_example"; // String | SpatialSource UID

var opts = { 
  'envelope': "envelope_example", // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
  'page': 56, // Number | Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
  'sort': "sort_example", // String | The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
  'fields': ["fields_example"] // [String] | Comma separated list of field names
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.getSpatialSourceAddDocs(spatialsourceUid, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **spatialsourceUid** | **String**| SpatialSource UID | 
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **page** | **Number**| Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. | [optional] 
 **sort** | **String**| The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. | [optional] 
 **fields** | [**[String]**](String.md)| Comma separated list of field names | [optional] 


### Return type

[**[AdditionalDocumentsEndpointType]**](AdditionalDocumentsEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getSpatialSourceByUID"></a>
# **getSpatialSourceByUID**
> SpatialSourcesEndpointType getSpatialSourceByUID(spatialsourceUid, opts, responseAsResult = *false*)

Returns a single SpatialSource

Returns a single SpatialSource

### Example
```javascript
var Its4landPublicApi = require('its4land_public_api');

var apiInstance = new Its4landPublicApi.SpatialSourcesApi();

var spatialsourceUid = "spatialsourceUid_example"; // String | SpatialSource UID

var opts = { 
  'envelope': "envelope_example", // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
  'embed': ["embed_example"] // [String] | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.getSpatialSourceByUID(spatialsourceUid, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **spatialsourceUid** | **String**| SpatialSource UID | 
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **embed** | [**[String]**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 


### Return type

[**SpatialSourcesEndpointType**](SpatialSourcesEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getSpatialSourceSingleAddDoc"></a>
# **getSpatialSourceSingleAddDoc**
> [AdditionalDocumentsEndpointType] getSpatialSourceSingleAddDoc(spatialsourceUid, adddocUid, opts, responseAsResult = *false*)

Returns the additional documents of a spatial source

Returns the additional documents of a spatial source

### Example
```javascript
var Its4landPublicApi = require('its4land_public_api');

var apiInstance = new Its4landPublicApi.SpatialSourcesApi();

var spatialsourceUid = "spatialsourceUid_example"; // String | SpatialSource UID

var adddocUid = "adddocUid_example"; // String | SpatialSource UID

var opts = { 
  'envelope': "envelope_example", // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
  'fields': ["fields_example"] // [String] | Comma separated list of field names
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.getSpatialSourceSingleAddDoc(spatialsourceUid, adddocUid, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **spatialsourceUid** | **String**| SpatialSource UID | 
 **adddocUid** | **String**| SpatialSource UID | 
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **fields** | [**[String]**](String.md)| Comma separated list of field names | [optional] 


### Return type

[**[AdditionalDocumentsEndpointType]**](AdditionalDocumentsEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getSpatialSources"></a>
# **getSpatialSources**
> [SpatialSourcesEndpointType] getSpatialSources(opts, responseAsResult = *false*)

Returns a list of SpatialSources

Returns a list of SpatialSources

### Example
```javascript
var Its4landPublicApi = require('its4land_public_api');

var apiInstance = new Its4landPublicApi.SpatialSourcesApi();

var opts = { 
  'envelope': "envelope_example", // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
  'uid': ["uid_example"], // [String] | Comma separated list of SpatialSources UID
  'name': ["name_example"], // [String] | Comma separated list of SpatialSources names
  'type': ["type_example"], // [String] | Comma separated list of SpatialSources types
  'projects': ["projects_example"], // [String] | Comma separated list of project UID
  'tags': ["tags_example"], // [String] | Comma separated list of tags
  'page': 56, // Number | Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
  'sort': "sort_example", // String | The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
  'fields': ["fields_example"], // [String] | Comma separated list of tags
  'embed': ["embed_example"] // [String] | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.getSpatialSources(opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **uid** | [**[String]**](String.md)| Comma separated list of SpatialSources UID | [optional] 
 **name** | [**[String]**](String.md)| Comma separated list of SpatialSources names | [optional] 
 **type** | [**[String]**](String.md)| Comma separated list of SpatialSources types | [optional] 
 **projects** | [**[String]**](String.md)| Comma separated list of project UID | [optional] 
 **tags** | [**[String]**](String.md)| Comma separated list of tags | [optional] 
 **page** | **Number**| Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. | [optional] 
 **sort** | **String**| The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. | [optional] 
 **fields** | [**[String]**](String.md)| Comma separated list of tags | [optional] 
 **embed** | [**[String]**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 


### Return type

[**[SpatialSourcesEndpointType]**](SpatialSourcesEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="newSpatialSource"></a>
# **newSpatialSource**
> SpatialSourcesEndpointType newSpatialSource(newspatialsource, opts, responseAsResult = *false*)

Create a new SpatialSource

Create a new SpatialSource. To add a new SpatialSources , the content of SpatialSources  must be stored in advanced via the ContentItem endpoint.

### Example
```javascript
var Its4landPublicApi = require('its4land_public_api');

var apiInstance = new Its4landPublicApi.SpatialSourcesApi();

var newspatialsource = new Its4landPublicApi.SpatialSourcesPostRequest(); // SpatialSourcesPostRequest | New SpatialSource data

var opts = { 
  'envelope': "envelope_example", // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
  'embed': ["embed_example"], // [String] | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
  'processUid': "processUid_example", // String | deprecated
  'i4lProcessUid': "i4lProcessUid_example" // String | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.newSpatialSource(newspatialsource, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **newspatialsource** | [**SpatialSourcesPostRequest**](SpatialSourcesPostRequest.md)| New SpatialSource data | 
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **embed** | [**[String]**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 
 **processUid** | **String**| deprecated | [optional] 
 **i4lProcessUid** | **String**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional] 


### Return type

[**SpatialSourcesEndpointType**](SpatialSourcesEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="newSpatialSourceAddAddDoc"></a>
# **newSpatialSourceAddAddDoc**
> AdditionalDocumentsEndpointType newSpatialSourceAddAddDoc(spatialsourceUid, newadddocdata, opts, responseAsResult = *false*)

Add a new additional document to a spatial source

Add a new additional document to a spatial source

### Example
```javascript
var Its4landPublicApi = require('its4land_public_api');

var apiInstance = new Its4landPublicApi.SpatialSourcesApi();

var spatialsourceUid = "spatialsourceUid_example"; // String | SpatialSource UID

var newadddocdata = new Its4landPublicApi.AdditionalDocumentsPost(); // AdditionalDocumentsPost | New additional document data

var opts = { 
  'envelope': "envelope_example", // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
  'i4lProcessUid': "i4lProcessUid_example" // String | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.newSpatialSourceAddAddDoc(spatialsourceUid, newadddocdata, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **spatialsourceUid** | **String**| SpatialSource UID | 
 **newadddocdata** | [**AdditionalDocumentsPost**](AdditionalDocumentsPost.md)| New additional document data | 
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **i4lProcessUid** | **String**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional] 


### Return type

[**AdditionalDocumentsEndpointType**](AdditionalDocumentsEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="putSpatialSourceByUID"></a>
# **putSpatialSourceByUID**
> SpatialSourcesEndpointType putSpatialSourceByUID(spatialsourceUid, updatedspatialsource, opts, responseAsResult = *false*)

Replace an existing SpatialSource by a newer version

An existing SpatialSource will be replaced by a newer version. The UID of SpatialSource remains

### Example
```javascript
var Its4landPublicApi = require('its4land_public_api');

var apiInstance = new Its4landPublicApi.SpatialSourcesApi();

var spatialsourceUid = "spatialsourceUid_example"; // String | SpatialSource UID

var updatedspatialsource = new Its4landPublicApi.SpatialSourcesPostRequest(); // SpatialSourcesPostRequest | Updated spatial source

var opts = { 
  'envelope': "envelope_example", // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
  'embed': ["embed_example"], // [String] | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
  'i4lProcessUid': "i4lProcessUid_example" // String | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.putSpatialSourceByUID(spatialsourceUid, updatedspatialsource, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **spatialsourceUid** | **String**| SpatialSource UID | 
 **updatedspatialsource** | [**SpatialSourcesPostRequest**](SpatialSourcesPostRequest.md)| Updated spatial source | 
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **embed** | [**[String]**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 
 **i4lProcessUid** | **String**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional] 


### Return type

[**SpatialSourcesEndpointType**](SpatialSourcesEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

