/**
 * its4land Public API
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/AdminSourcesEndpointType', 'model/AdminSourcesPostRequest', 'model/RFC6902PatchRequest'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/AdminSourcesEndpointType'), require('../model/AdminSourcesPostRequest'), require('../model/RFC6902PatchRequest'));
  } else {
    // Browser globals (root is window)
    if (!root.Its4landPublicApi) {
      root.Its4landPublicApi = {};
    }
    root.Its4landPublicApi.AdminSourcesApi = factory(root.Its4landPublicApi.ApiClient, root.Its4landPublicApi.AdminSourcesEndpointType, root.Its4landPublicApi.AdminSourcesPostRequest, root.Its4landPublicApi.RFC6902PatchRequest);
  }
}(this, function(ApiClient, AdminSourcesEndpointType, AdminSourcesPostRequest, RFC6902PatchRequest) {
  'use strict';

  /**
   * AdminSources service.
   * @module api/AdminSourcesApi
   * @version 0.0.2
   */

  /**
   * Constructs a new AdminSourcesApi. 
   * @alias module:api/AdminSourcesApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the getAdminSourceByUID operation.
     * @callback module:api/AdminSourcesApi~getAdminSourceByUIDCallback
     * @param {String} error Error message, if any.
     * @param {module:model/AdminSourcesEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Returns a single Admin Source
     * Returns a single Admin Source
     * @param {String} adminsourceUid AdminSource UID
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {module:api/AdminSourcesApi~getAdminSourceByUIDCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/AdminSourcesEndpointType}
     */
    this.getAdminSourceByUID = function(adminsourceUid, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'adminsourceUid' is set
      if (adminsourceUid === undefined || adminsourceUid === null) {
        throw new Error("Missing the required parameter 'adminsourceUid' when calling getAdminSourceByUID");
      }


      var pathParams = {
        'adminsource_uid': adminsourceUid
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = AdminSourcesEndpointType;

      return this.apiClient.callApi(
        '/adminsources/{adminsource_uid}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getAdminSources operation.
     * @callback module:api/AdminSourcesApi~getAdminSourcesCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/AdminSourcesEndpointType>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Returns a list of AdminSource document indizes
     * Returns a list of AdminSource document indizes
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.uid Comma separated list of AdminSources UID
     * @param {Array.<String>} opts.name Comma separated list of AdminSources names
     * @param {Array.<String>} opts.type Comma separated list of AdminSources types
     * @param {Array.<String>} opts.projects Comma separated list of project UID
     * @param {Array.<String>} opts.spatialunits Comma separated list of SpatialUnit UID
     * @param {Array.<String>} opts.tags Comma separated list of tags
     * @param {Number} opts.page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
     * @param {String} opts.sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
     * @param {Array.<String>} opts.fields Comma separated list of tags
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {module:api/AdminSourcesApi~getAdminSourcesCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/AdminSourcesEndpointType>}
     */
    this.getAdminSources = function(opts, callback) {
      opts = opts || {};
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
        'envelope': opts['envelope'],
        'page': opts['page'],
        'sort': opts['sort'],
      };
      var collectionQueryParams = {
        'uid': {
          value: opts['uid'],
          collectionFormat: 'csv'
        },
        'name': {
          value: opts['name'],
          collectionFormat: 'csv'
        },
        'type': {
          value: opts['type'],
          collectionFormat: 'csv'
        },
        'projects': {
          value: opts['projects'],
          collectionFormat: 'csv'
        },
        'spatialunits': {
          value: opts['spatialunits'],
          collectionFormat: 'csv'
        },
        'tags': {
          value: opts['tags'],
          collectionFormat: 'csv'
        },
        'fields': {
          value: opts['fields'],
          collectionFormat: 'csv'
        },
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [AdminSourcesEndpointType];

      return this.apiClient.callApi(
        '/adminsources', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the newAdminSource operation.
     * @callback module:api/AdminSourcesApi~newAdminSourceCallback
     * @param {String} error Error message, if any.
     * @param {module:model/AdminSourcesEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Creates a new AdminSource
     * Creates a new AdminSource
     * @param {module:model/AdminSourcesPostRequest} newadminsource New AdminSource data
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {String} opts.i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
     * @param {module:api/AdminSourcesApi~newAdminSourceCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/AdminSourcesEndpointType}
     */
    this.newAdminSource = function(newadminsource, opts, callback) {
      opts = opts || {};
      var postBody = newadminsource;

      // verify the required parameter 'newadminsource' is set
      if (newadminsource === undefined || newadminsource === null) {
        throw new Error("Missing the required parameter 'newadminsource' when calling newAdminSource");
      }


      var pathParams = {
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
        'i4l-process-uid': opts['i4lProcessUid']
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = AdminSourcesEndpointType;

      return this.apiClient.callApi(
        '/adminsources', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the updateAdminSource operation.
     * @callback module:api/AdminSourcesApi~updateAdminSourceCallback
     * @param {String} error Error message, if any.
     * @param {module:model/AdminSourcesEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update an Admin Source
     * Update an Admin Source
     * @param {String} adminsourceUid AdminSource UID
     * @param {module:model/RFC6902PatchRequest} patchadminsource Update data
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {String} opts.i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
     * @param {module:api/AdminSourcesApi~updateAdminSourceCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/AdminSourcesEndpointType}
     */
    this.updateAdminSource = function(adminsourceUid, patchadminsource, opts, callback) {
      opts = opts || {};
      var postBody = patchadminsource;

      // verify the required parameter 'adminsourceUid' is set
      if (adminsourceUid === undefined || adminsourceUid === null) {
        throw new Error("Missing the required parameter 'adminsourceUid' when calling updateAdminSource");
      }

      // verify the required parameter 'patchadminsource' is set
      if (patchadminsource === undefined || patchadminsource === null) {
        throw new Error("Missing the required parameter 'patchadminsource' when calling updateAdminSource");
      }


      var pathParams = {
        'adminsource_uid': adminsourceUid
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'i4l-process-uid': opts['i4lProcessUid']
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = AdminSourcesEndpointType;

      return this.apiClient.callApi(
        '/adminsources/{adminsource_uid}', 'PATCH',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
