/**
 * its4land Public API
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/ModelClassesEndpointType', 'model/RFC6902PatchRequest'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/ModelClassesEndpointType'), require('../model/RFC6902PatchRequest'));
  } else {
    // Browser globals (root is window)
    if (!root.Its4landPublicApi) {
      root.Its4landPublicApi = {};
    }
    root.Its4landPublicApi.ModelClassesApi = factory(root.Its4landPublicApi.ApiClient, root.Its4landPublicApi.ModelClassesEndpointType, root.Its4landPublicApi.RFC6902PatchRequest);
  }
}(this, function(ApiClient, ModelClassesEndpointType, RFC6902PatchRequest) {
  'use strict';

  /**
   * ModelClasses service.
   * @module api/ModelClassesApi
   * @version 0.0.2
   */

  /**
   * Constructs a new ModelClassesApi. 
   * @alias module:api/ModelClassesApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the getModelClasses operation.
     * @callback module:api/ModelClassesApi~getModelClassesCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/ModelClassesEndpointType>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Returns ModelClasses
     * Returns ModelClasses
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.UID Comma separated list of ModelClasses UID
     * @param {Array.<String>} opts.nameinmodel Comma separated list of ModelClasses names
     * @param {Array.<String>} opts.conceptname Comma separated list of ModelClasses concept names
     * @param {Number} opts.page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
     * @param {String} opts.sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
     * @param {Array.<String>} opts.fields Comma separated list of field names
     * @param {module:api/ModelClassesApi~getModelClassesCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/ModelClassesEndpointType>}
     */
    this.getModelClasses = function(opts, callback) {
      opts = opts || {};
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
        'envelope': opts['envelope'],
        'page': opts['page'],
        'sort': opts['sort'],
      };
      var collectionQueryParams = {
        'UID': {
          value: opts['UID'],
          collectionFormat: 'csv'
        },
        'nameinmodel': {
          value: opts['nameinmodel'],
          collectionFormat: 'csv'
        },
        'conceptname': {
          value: opts['conceptname'],
          collectionFormat: 'csv'
        },
        'fields': {
          value: opts['fields'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [ModelClassesEndpointType];

      return this.apiClient.callApi(
        '/modelclasses', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getModelClassesByUID operation.
     * @callback module:api/ModelClassesApi~getModelClassesByUIDCallback
     * @param {String} error Error message, if any.
     * @param {module:model/ModelClassesEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Returns a single model class
     * Returns a single model class
     * @param {String} modelclassesUid ModelClass UID
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {module:api/ModelClassesApi~getModelClassesByUIDCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/ModelClassesEndpointType}
     */
    this.getModelClassesByUID = function(modelclassesUid, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'modelclassesUid' is set
      if (modelclassesUid === undefined || modelclassesUid === null) {
        throw new Error("Missing the required parameter 'modelclassesUid' when calling getModelClassesByUID");
      }


      var pathParams = {
        'modelclasses_uid': modelclassesUid
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = ModelClassesEndpointType;

      return this.apiClient.callApi(
        '/modelclasses/{modelclasses_uid}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the updateModelClasses operation.
     * @callback module:api/ModelClassesApi~updateModelClassesCallback
     * @param {String} error Error message, if any.
     * @param {module:model/ModelClassesEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Updates some attributes of a ModelClass
     * Updates some attributes of a ModelClass
     * @param {String} modelclassesUid ModelClass UID
     * @param {module:model/RFC6902PatchRequest} patchmodelclasses Update data
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {String} opts.i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
     * @param {module:api/ModelClassesApi~updateModelClassesCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/ModelClassesEndpointType}
     */
    this.updateModelClasses = function(modelclassesUid, patchmodelclasses, opts, callback) {
      opts = opts || {};
      var postBody = patchmodelclasses;

      // verify the required parameter 'modelclassesUid' is set
      if (modelclassesUid === undefined || modelclassesUid === null) {
        throw new Error("Missing the required parameter 'modelclassesUid' when calling updateModelClasses");
      }

      // verify the required parameter 'patchmodelclasses' is set
      if (patchmodelclasses === undefined || patchmodelclasses === null) {
        throw new Error("Missing the required parameter 'patchmodelclasses' when calling updateModelClasses");
      }


      var pathParams = {
        'modelclasses_uid': modelclassesUid
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'i4l-process-uid': opts['i4lProcessUid']
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = ModelClassesEndpointType;

      return this.apiClient.callApi(
        '/modelclasses/{modelclasses_uid}', 'PATCH',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
