/**
 * its4land Public API
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/ModelClassesEndpointType', 'model/ModelClassesPostRequest', 'model/ModelsEndpointType', 'model/ModelsPostRequest', 'model/RFC6902PatchRequest'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/ModelClassesEndpointType'), require('../model/ModelClassesPostRequest'), require('../model/ModelsEndpointType'), require('../model/ModelsPostRequest'), require('../model/RFC6902PatchRequest'));
  } else {
    // Browser globals (root is window)
    if (!root.Its4landPublicApi) {
      root.Its4landPublicApi = {};
    }
    root.Its4landPublicApi.ModelsApi = factory(root.Its4landPublicApi.ApiClient, root.Its4landPublicApi.ModelClassesEndpointType, root.Its4landPublicApi.ModelClassesPostRequest, root.Its4landPublicApi.ModelsEndpointType, root.Its4landPublicApi.ModelsPostRequest, root.Its4landPublicApi.RFC6902PatchRequest);
  }
}(this, function(ApiClient, ModelClassesEndpointType, ModelClassesPostRequest, ModelsEndpointType, ModelsPostRequest, RFC6902PatchRequest) {
  'use strict';

  /**
   * Models service.
   * @module api/ModelsApi
   * @version 0.0.2
   */

  /**
   * Constructs a new ModelsApi. 
   * @alias module:api/ModelsApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the getModels operation.
     * @callback module:api/ModelsApi~getModelsCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/ModelsEndpointType>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Returns a list of models.
     * Returns a list of models.
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.uid Comma separated list of model UID
     * @param {Array.<String>} opts.name Comma separated list of model names
     * @param {Array.<String>} opts.tools Comma separated list tool names which can make use of the model.
     * @param {Array.<String>} opts.projects Comma separated list of project UID
     * @param {Array.<String>} opts.tags Comma separated list of tags
     * @param {Number} opts.page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
     * @param {String} opts.sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
     * @param {Array.<String>} opts.fields Comma separated list of field names
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {module:api/ModelsApi~getModelsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/ModelsEndpointType>}
     */
    this.getModels = function(opts, callback) {
      opts = opts || {};
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
        'envelope': opts['envelope'],
        'page': opts['page'],
        'sort': opts['sort'],
      };
      var collectionQueryParams = {
        'uid': {
          value: opts['uid'],
          collectionFormat: 'csv'
        },
        'name': {
          value: opts['name'],
          collectionFormat: 'csv'
        },
        'tools': {
          value: opts['tools'],
          collectionFormat: 'csv'
        },
        'projects': {
          value: opts['projects'],
          collectionFormat: 'csv'
        },
        'tags': {
          value: opts['tags'],
          collectionFormat: 'csv'
        },
        'fields': {
          value: opts['fields'],
          collectionFormat: 'csv'
        },
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [ModelsEndpointType];

      return this.apiClient.callApi(
        '/models', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getModelsByUID operation.
     * @callback module:api/ModelsApi~getModelsByUIDCallback
     * @param {String} error Error message, if any.
     * @param {module:model/ModelsEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Returns a single model
     * Returns a single model
     * @param {String} modelUid Model  UID
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {module:api/ModelsApi~getModelsByUIDCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/ModelsEndpointType}
     */
    this.getModelsByUID = function(modelUid, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'modelUid' is set
      if (modelUid === undefined || modelUid === null) {
        throw new Error("Missing the required parameter 'modelUid' when calling getModelsByUID");
      }


      var pathParams = {
        'model_uid': modelUid
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = ModelsEndpointType;

      return this.apiClient.callApi(
        '/models/{model_uid}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getModelsClassesByModel operation.
     * @callback module:api/ModelsApi~getModelsClassesByModelCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/ModelClassesEndpointType>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Returns the model classes of the classifier.
     * Returns the model classes of the classifier.
     * @param {String} modelUid Model  UID
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {module:api/ModelsApi~getModelsClassesByModelCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/ModelClassesEndpointType>}
     */
    this.getModelsClassesByModel = function(modelUid, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'modelUid' is set
      if (modelUid === undefined || modelUid === null) {
        throw new Error("Missing the required parameter 'modelUid' when calling getModelsClassesByModel");
      }


      var pathParams = {
        'model_uid': modelUid
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [ModelClassesEndpointType];

      return this.apiClient.callApi(
        '/models/{model_uid}/modelclasses', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the newModel operation.
     * @callback module:api/ModelsApi~newModelCallback
     * @param {String} error Error message, if any.
     * @param {module:model/ModelsEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create a new model
     * Create a new model. The model can be assigned to a project via the patch://project method. To add a new SpatialSources , the content of Models  must be stored in advanced via the ContentItem endpoint
     * @param {module:model/ModelsPostRequest} newmodel New Model data
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {String} opts.i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
     * @param {module:api/ModelsApi~newModelCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/ModelsEndpointType}
     */
    this.newModel = function(newmodel, opts, callback) {
      opts = opts || {};
      var postBody = newmodel;

      // verify the required parameter 'newmodel' is set
      if (newmodel === undefined || newmodel === null) {
        throw new Error("Missing the required parameter 'newmodel' when calling newModel");
      }


      var pathParams = {
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
        'i4l-process-uid': opts['i4lProcessUid']
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = ModelsEndpointType;

      return this.apiClient.callApi(
        '/models', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the newModelClassUnderModel operation.
     * @callback module:api/ModelsApi~newModelClassUnderModelCallback
     * @param {String} error Error message, if any.
     * @param {module:model/ModelClassesEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create a new ModelClass under a model
     * Create a new ModelClass under a model
     * @param {String} modelUid Model  UID
     * @param {module:model/ModelClassesPostRequest} newmodelclass New ModelClass data
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {String} opts.i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
     * @param {module:api/ModelsApi~newModelClassUnderModelCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/ModelClassesEndpointType}
     */
    this.newModelClassUnderModel = function(modelUid, newmodelclass, opts, callback) {
      opts = opts || {};
      var postBody = newmodelclass;

      // verify the required parameter 'modelUid' is set
      if (modelUid === undefined || modelUid === null) {
        throw new Error("Missing the required parameter 'modelUid' when calling newModelClassUnderModel");
      }

      // verify the required parameter 'newmodelclass' is set
      if (newmodelclass === undefined || newmodelclass === null) {
        throw new Error("Missing the required parameter 'newmodelclass' when calling newModelClassUnderModel");
      }


      var pathParams = {
        'model_uid': modelUid
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
        'i4l-process-uid': opts['i4lProcessUid']
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = ModelClassesEndpointType;

      return this.apiClient.callApi(
        '/models/{model_uid}/modelclasses', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the updateModels operation.
     * @callback module:api/ModelsApi~updateModelsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/ModelsEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Updates some attributes of a model
     * Updates some attributes of a model
     * @param {String} modelUid Model  UID
     * @param {module:model/RFC6902PatchRequest} patchmodel Update data
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {String} opts.i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
     * @param {module:api/ModelsApi~updateModelsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/ModelsEndpointType}
     */
    this.updateModels = function(modelUid, patchmodel, opts, callback) {
      opts = opts || {};
      var postBody = patchmodel;

      // verify the required parameter 'modelUid' is set
      if (modelUid === undefined || modelUid === null) {
        throw new Error("Missing the required parameter 'modelUid' when calling updateModels");
      }

      // verify the required parameter 'patchmodel' is set
      if (patchmodel === undefined || patchmodel === null) {
        throw new Error("Missing the required parameter 'patchmodel' when calling updateModels");
      }


      var pathParams = {
        'model_uid': modelUid
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
        'i4l-process-uid': opts['i4lProcessUid']
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = ModelsEndpointType;

      return this.apiClient.callApi(
        '/models/{model_uid}', 'PATCH',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
