/**
 * its4land Public API
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/LogEntryEndpointType', 'model/LogEntryPostRequest', 'model/ProcessEndpointType', 'model/ProcessPostRequest'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/LogEntryEndpointType'), require('../model/LogEntryPostRequest'), require('../model/ProcessEndpointType'), require('../model/ProcessPostRequest'));
  } else {
    // Browser globals (root is window)
    if (!root.Its4landPublicApi) {
      root.Its4landPublicApi = {};
    }
    root.Its4landPublicApi.ProcessesApi = factory(root.Its4landPublicApi.ApiClient, root.Its4landPublicApi.LogEntryEndpointType, root.Its4landPublicApi.LogEntryPostRequest, root.Its4landPublicApi.ProcessEndpointType, root.Its4landPublicApi.ProcessPostRequest);
  }
}(this, function(ApiClient, LogEntryEndpointType, LogEntryPostRequest, ProcessEndpointType, ProcessPostRequest) {
  'use strict';

  /**
   * Processes service.
   * @module api/ProcessesApi
   * @version 0.0.2
   */

  /**
   * Constructs a new ProcessesApi. 
   * @alias module:api/ProcessesApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the createProcessLog operation.
     * @callback module:api/ProcessesApi~createProcessLogCallback
     * @param {String} error Error message, if any.
     * @param {module:model/LogEntryEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Writes a single log entry
     * Writes a single log entry
     * @param {String} processUid Process UID
     * @param {module:model/LogEntryPostRequest} newlogentry New log entry
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {String} opts.i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
     * @param {module:api/ProcessesApi~createProcessLogCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/LogEntryEndpointType}
     */
    this.createProcessLog = function(processUid, newlogentry, opts, callback) {
      opts = opts || {};
      var postBody = newlogentry;

      // verify the required parameter 'processUid' is set
      if (processUid === undefined || processUid === null) {
        throw new Error("Missing the required parameter 'processUid' when calling createProcessLog");
      }

      // verify the required parameter 'newlogentry' is set
      if (newlogentry === undefined || newlogentry === null) {
        throw new Error("Missing the required parameter 'newlogentry' when calling createProcessLog");
      }


      var pathParams = {
        'process_uid': processUid
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'i4l-process-uid': opts['i4lProcessUid']
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = LogEntryEndpointType;

      return this.apiClient.callApi(
        '/processes/{process_uid}/log', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the createProcesses operation.
     * @callback module:api/ProcessesApi~createProcessesCallback
     * @param {String} error Error message, if any.
     * @param {module:model/ProcessEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Creates a new  processes
     * Creates a new  processes
     * @param {module:model/ProcessPostRequest} newprocess New process metadata
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {String} opts.i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
     * @param {module:api/ProcessesApi~createProcessesCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/ProcessEndpointType}
     */
    this.createProcesses = function(newprocess, opts, callback) {
      opts = opts || {};
      var postBody = newprocess;

      // verify the required parameter 'newprocess' is set
      if (newprocess === undefined || newprocess === null) {
        throw new Error("Missing the required parameter 'newprocess' when calling createProcesses");
      }


      var pathParams = {
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
        'i4l-process-uid': opts['i4lProcessUid']
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = ProcessEndpointType;

      return this.apiClient.callApi(
        '/processes', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getProcessByUID operation.
     * @callback module:api/ProcessesApi~getProcessByUIDCallback
     * @param {String} error Error message, if any.
     * @param {module:model/ProcessEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Returns metadata for a single process
     * Returns metadata for a single process
     * @param {String} processUid Process UID
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {module:api/ProcessesApi~getProcessByUIDCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/ProcessEndpointType}
     */
    this.getProcessByUID = function(processUid, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'processUid' is set
      if (processUid === undefined || processUid === null) {
        throw new Error("Missing the required parameter 'processUid' when calling getProcessByUID");
      }


      var pathParams = {
        'process_uid': processUid
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = ProcessEndpointType;

      return this.apiClient.callApi(
        '/processes/{process_uid}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getProcessLog operation.
     * @callback module:api/ProcessesApi~getProcessLogCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/LogEntryEndpointType>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get the full log of a process
     * Get the full log of a process. Oldest entry first
     * @param {String} processUid Process UID
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.loglevel LogLevel : error, info, warning, debug. Default is info. The higher order level includes the lower level
     * @param {Array.<String>} opts.logsource Source of the log entry. Values: GUI, &lt;ToolName&gt;
     * @param {Number} opts.page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
     * @param {String} opts.sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
     * @param {Array.<String>} opts.fields Comma separated list of field names
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {module:api/ProcessesApi~getProcessLogCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/LogEntryEndpointType>}
     */
    this.getProcessLog = function(processUid, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'processUid' is set
      if (processUid === undefined || processUid === null) {
        throw new Error("Missing the required parameter 'processUid' when calling getProcessLog");
      }


      var pathParams = {
        'process_uid': processUid
      };
      var queryParams = {
        'envelope': opts['envelope'],
        'page': opts['page'],
        'sort': opts['sort'],
      };
      var collectionQueryParams = {
        'loglevel': {
          value: opts['loglevel'],
          collectionFormat: 'csv'
        },
        'logsource': {
          value: opts['logsource'],
          collectionFormat: 'csv'
        },
        'fields': {
          value: opts['fields'],
          collectionFormat: 'csv'
        },
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [LogEntryEndpointType];

      return this.apiClient.callApi(
        '/processes/{process_uid}/log', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getProcesses operation.
     * @callback module:api/ProcessesApi~getProcessesCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/ProcessEndpointType>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get a list of processes
     * Get a list of processes
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.uid Comma separated list of Tag UID
     * @param {Array.<String>} opts.project Comma separated list of project uid
     * @param {module:model/String} opts.status Status of the project. Can be one of:   * WAITING: Process is queued for execution   * RUNNING: Process is currently executing   * FINISHED: Process terminated normally   * ABORTED: Process terminated unexpectedly   * ZOMBIE: Process is listed in the platform process table, but the internal (process) API has no information about it. Possible in case of historical/archived processes or due to platform error. 
     * @param {Array.<String>} opts.tooluid Comma separated list of tool UID
     * @param {Number} opts.page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
     * @param {String} opts.sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
     * @param {Array.<String>} opts.fields Comma separated list of fields
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {module:api/ProcessesApi~getProcessesCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/ProcessEndpointType>}
     */
    this.getProcesses = function(opts, callback) {
      opts = opts || {};
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
        'envelope': opts['envelope'],
        'status': opts['status'],
        'page': opts['page'],
        'sort': opts['sort'],
      };
      var collectionQueryParams = {
        'uid': {
          value: opts['uid'],
          collectionFormat: 'csv'
        },
        'project': {
          value: opts['project'],
          collectionFormat: 'csv'
        },
        'tooluid': {
          value: opts['tooluid'],
          collectionFormat: 'csv'
        },
        'fields': {
          value: opts['fields'],
          collectionFormat: 'csv'
        },
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [ProcessEndpointType];

      return this.apiClient.callApi(
        '/processes', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
