/**
 * its4land Public API
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/ConnectedObjectsEndpointType', 'model/ModelsEndpointType', 'model/ModelsPostRequest', 'model/ProjectsEndpointType', 'model/ProjectsPostRequest', 'model/RFC6902PatchRequest', 'model/SpatialSourcesEndpointType', 'model/SpatialSourcesPostRequest', 'model/TagsListResponse', 'model/TagsPostRequest'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/ConnectedObjectsEndpointType'), require('../model/ModelsEndpointType'), require('../model/ModelsPostRequest'), require('../model/ProjectsEndpointType'), require('../model/ProjectsPostRequest'), require('../model/RFC6902PatchRequest'), require('../model/SpatialSourcesEndpointType'), require('../model/SpatialSourcesPostRequest'), require('../model/TagsListResponse'), require('../model/TagsPostRequest'));
  } else {
    // Browser globals (root is window)
    if (!root.Its4landPublicApi) {
      root.Its4landPublicApi = {};
    }
    root.Its4landPublicApi.ProjectsApi = factory(root.Its4landPublicApi.ApiClient, root.Its4landPublicApi.ConnectedObjectsEndpointType, root.Its4landPublicApi.ModelsEndpointType, root.Its4landPublicApi.ModelsPostRequest, root.Its4landPublicApi.ProjectsEndpointType, root.Its4landPublicApi.ProjectsPostRequest, root.Its4landPublicApi.RFC6902PatchRequest, root.Its4landPublicApi.SpatialSourcesEndpointType, root.Its4landPublicApi.SpatialSourcesPostRequest, root.Its4landPublicApi.TagsListResponse, root.Its4landPublicApi.TagsPostRequest);
  }
}(this, function(ApiClient, ConnectedObjectsEndpointType, ModelsEndpointType, ModelsPostRequest, ProjectsEndpointType, ProjectsPostRequest, RFC6902PatchRequest, SpatialSourcesEndpointType, SpatialSourcesPostRequest, TagsListResponse, TagsPostRequest) {
  'use strict';

  /**
   * Projects service.
   * @module api/ProjectsApi
   * @version 0.0.2
   */

  /**
   * Constructs a new ProjectsApi. 
   * @alias module:api/ProjectsApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the addTagToProject operation.
     * @callback module:api/ProjectsApi~addTagToProjectCallback
     * @param {String} error Error message, if any.
     * @param {module:model/ProjectsEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Adds a tag to the project
     * Creates a new tag and attach it to the project. If the tag already exist, the existing tag will be attached to the project.
     * @param {String} projectUid Project UID
     * @param {module:model/TagsPostRequest} newtag New Tag data
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {String} opts.i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
     * @param {module:api/ProjectsApi~addTagToProjectCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/ProjectsEndpointType}
     */
    this.addTagToProject = function(projectUid, newtag, opts, callback) {
      opts = opts || {};
      var postBody = newtag;

      // verify the required parameter 'projectUid' is set
      if (projectUid === undefined || projectUid === null) {
        throw new Error("Missing the required parameter 'projectUid' when calling addTagToProject");
      }

      // verify the required parameter 'newtag' is set
      if (newtag === undefined || newtag === null) {
        throw new Error("Missing the required parameter 'newtag' when calling addTagToProject");
      }


      var pathParams = {
        'project_uid': projectUid
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
        'i4l-process-uid': opts['i4lProcessUid']
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = ProjectsEndpointType;

      return this.apiClient.callApi(
        '/projects/{project_uid}/Tags', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the delProjectByUID operation.
     * @callback module:api/ProjectsApi~delProjectByUIDCallback
     * @param {String} error Error message, if any.
     * @param {module:model/ProjectsEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Deletes a single e project by its UID
     * A single project is deleted. This endpoint deletes the project itself and the connected to subordered data like SpatialSources, etc. The subordered data itself are not deleted
     * @param {String} projectUid UID of the project
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {String} opts.i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
     * @param {module:api/ProjectsApi~delProjectByUIDCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/ProjectsEndpointType}
     */
    this.delProjectByUID = function(projectUid, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'projectUid' is set
      if (projectUid === undefined || projectUid === null) {
        throw new Error("Missing the required parameter 'projectUid' when calling delProjectByUID");
      }


      var pathParams = {
        'project_uid': projectUid
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
        'i4l-process-uid': opts['i4lProcessUid']
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = ProjectsEndpointType;

      return this.apiClient.callApi(
        '/projects/{project_uid}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the detachProjectModel operation.
     * @callback module:api/ProjectsApi~detachProjectModelCallback
     * @param {String} error Error message, if any.
     * @param {module:model/ProjectsEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Removes a model from a project.
     * Removes a model from a project. By default only the link between model and project is removed.
     * @param {String} projectUid Project UID
     * @param {String} modelUid Model UID
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {String} opts.forceDelete Deletes the model resource. ********* What&#39;s about subordinate resources? *********
     * @param {module:api/ProjectsApi~detachProjectModelCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/ProjectsEndpointType}
     */
    this.detachProjectModel = function(projectUid, modelUid, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'projectUid' is set
      if (projectUid === undefined || projectUid === null) {
        throw new Error("Missing the required parameter 'projectUid' when calling detachProjectModel");
      }

      // verify the required parameter 'modelUid' is set
      if (modelUid === undefined || modelUid === null) {
        throw new Error("Missing the required parameter 'modelUid' when calling detachProjectModel");
      }


      var pathParams = {
        'project_uid': projectUid,
        'model_uid': modelUid
      };
      var queryParams = {
        'envelope': opts['envelope'],
        'force_delete': opts['forceDelete'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = ProjectsEndpointType;

      return this.apiClient.callApi(
        '/projects/{project_uid}/Models/{model_uid}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the detachProjectSpatialSource operation.
     * @callback module:api/ProjectsApi~detachProjectSpatialSourceCallback
     * @param {String} error Error message, if any.
     * @param {module:model/ProjectsEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Removes a spatialsource from a project.
     * Removes a spatial from a project. By default only the link between spatialsource and project is removed.
     * @param {String} projectUid Project UID
     * @param {String} spatialsourceUid SpatialSource UID
     * @param {Object} opts Optional parameters
     * @param {String} opts.forceDelete Deletes the spatialsource resource. ********* What&#39;s about subordinate resources? *********
     * @param {module:api/ProjectsApi~detachProjectSpatialSourceCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/ProjectsEndpointType}
     */
    this.detachProjectSpatialSource = function(projectUid, spatialsourceUid, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'projectUid' is set
      if (projectUid === undefined || projectUid === null) {
        throw new Error("Missing the required parameter 'projectUid' when calling detachProjectSpatialSource");
      }

      // verify the required parameter 'spatialsourceUid' is set
      if (spatialsourceUid === undefined || spatialsourceUid === null) {
        throw new Error("Missing the required parameter 'spatialsourceUid' when calling detachProjectSpatialSource");
      }


      var pathParams = {
        'project_uid': projectUid,
        'spatialsource_uid': spatialsourceUid
      };
      var queryParams = {
        'force_delete': opts['forceDelete'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = ProjectsEndpointType;

      return this.apiClient.callApi(
        '/projects/{project_uid}/SpatialSources/{spatialsource_uid}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the detachProjectTag operation.
     * @callback module:api/ProjectsApi~detachProjectTagCallback
     * @param {String} error Error message, if any.
     * @param {module:model/ProjectsEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Removes a tag from a project.
     * Removes a tag from a project. By default only the link between tag and project is removed.
     * @param {String} projectUid Project UID
     * @param {String} tag tag value
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {String} opts.forceDelete Deletes the tag resource. ********* Only possible, when tag is not attached to any other resource. *********
     * @param {module:api/ProjectsApi~detachProjectTagCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/ProjectsEndpointType}
     */
    this.detachProjectTag = function(projectUid, tag, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'projectUid' is set
      if (projectUid === undefined || projectUid === null) {
        throw new Error("Missing the required parameter 'projectUid' when calling detachProjectTag");
      }

      // verify the required parameter 'tag' is set
      if (tag === undefined || tag === null) {
        throw new Error("Missing the required parameter 'tag' when calling detachProjectTag");
      }


      var pathParams = {
        'project_uid': projectUid,
        'tag': tag
      };
      var queryParams = {
        'envelope': opts['envelope'],
        'force_delete': opts['forceDelete'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = ProjectsEndpointType;

      return this.apiClient.callApi(
        '/projects/{project_uid}/Tags/{tag}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getConnectedObjectsByProjectUID operation.
     * @callback module:api/ProjectsApi~getConnectedObjectsByProjectUIDCallback
     * @param {String} error Error message, if any.
     * @param {module:model/ConnectedObjectsEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Returns an array of connect objects
     * Returns an array of connect objects of a project. For each connected object the endpoint returns the type, name and uuid
     * @param {String} projectUid Project UID
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Number} opts.page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
     * @param {String} opts.sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
     * @param {Array.<String>} opts.fields Comma separated list of field names
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {module:api/ProjectsApi~getConnectedObjectsByProjectUIDCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/ConnectedObjectsEndpointType}
     */
    this.getConnectedObjectsByProjectUID = function(projectUid, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'projectUid' is set
      if (projectUid === undefined || projectUid === null) {
        throw new Error("Missing the required parameter 'projectUid' when calling getConnectedObjectsByProjectUID");
      }


      var pathParams = {
        'project_uid': projectUid
      };
      var queryParams = {
        'envelope': opts['envelope'],
        'page': opts['page'],
        'sort': opts['sort'],
      };
      var collectionQueryParams = {
        'fields': {
          value: opts['fields'],
          collectionFormat: 'csv'
        },
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = ConnectedObjectsEndpointType;

      return this.apiClient.callApi(
        '/projects/{project_uid}/connectedObjects', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getModelsByProjectUID operation.
     * @callback module:api/ProjectsApi~getModelsByProjectUIDCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/ModelsEndpointType>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Returns the models of a project
     * Returns the models of a project
     * @param {String} projectUid Project UID
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Number} opts.page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
     * @param {String} opts.sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
     * @param {Array.<String>} opts.fields Comma separated list of field names
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {module:api/ProjectsApi~getModelsByProjectUIDCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/ModelsEndpointType>}
     */
    this.getModelsByProjectUID = function(projectUid, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'projectUid' is set
      if (projectUid === undefined || projectUid === null) {
        throw new Error("Missing the required parameter 'projectUid' when calling getModelsByProjectUID");
      }


      var pathParams = {
        'project_uid': projectUid
      };
      var queryParams = {
        'envelope': opts['envelope'],
        'page': opts['page'],
        'sort': opts['sort'],
      };
      var collectionQueryParams = {
        'fields': {
          value: opts['fields'],
          collectionFormat: 'csv'
        },
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [ModelsEndpointType];

      return this.apiClient.callApi(
        '/projects/{project_uid}/Models', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getProjectTagsByProjectUID operation.
     * @callback module:api/ProjectsApi~getProjectTagsByProjectUIDCallback
     * @param {String} error Error message, if any.
     * @param {module:model/TagsListResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Returns the tags of a project.
     * Is this method really necessary? Returns the tags of a project.
     * @param {String} projectUid Project UID
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {module:api/ProjectsApi~getProjectTagsByProjectUIDCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/TagsListResponse}
     */
    this.getProjectTagsByProjectUID = function(projectUid, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'projectUid' is set
      if (projectUid === undefined || projectUid === null) {
        throw new Error("Missing the required parameter 'projectUid' when calling getProjectTagsByProjectUID");
      }


      var pathParams = {
        'project_uid': projectUid
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = TagsListResponse;

      return this.apiClient.callApi(
        '/projects/{project_uid}/Tags', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getProjects operation.
     * @callback module:api/ProjectsApi~getProjectsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/ProjectsEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get a GeoJSON structure containing a list of Projects.
     * Get a GeoJSON structure containing a list of Projects. A single project is modeled as a GeoJSON feature.
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.uid Comma separated list of UID
     * @param {Array.<String>} opts.name Comma separated list of names
     * @param {String} opts.aoi Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1
     * @param {Array.<String>} opts.tags Comma separated list of tags
     * @param {Number} opts.page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
     * @param {String} opts.sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
     * @param {Array.<String>} opts.fields Comma separated list of field names
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {module:api/ProjectsApi~getProjectsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/ProjectsEndpointType}
     */
    this.getProjects = function(opts, callback) {
      opts = opts || {};
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
        'envelope': opts['envelope'],
        'aoi': opts['aoi'],
        'page': opts['page'],
        'sort': opts['sort'],
      };
      var collectionQueryParams = {
        'uid': {
          value: opts['uid'],
          collectionFormat: 'csv'
        },
        'name': {
          value: opts['name'],
          collectionFormat: 'csv'
        },
        'tags': {
          value: opts['tags'],
          collectionFormat: 'csv'
        },
        'fields': {
          value: opts['fields'],
          collectionFormat: 'csv'
        },
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = ProjectsEndpointType;

      return this.apiClient.callApi(
        '/projects', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getProjectsByUID operation.
     * @callback module:api/ProjectsApi~getProjectsByUIDCallback
     * @param {String} error Error message, if any.
     * @param {module:model/ProjectsEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Getting single Projects by its UID
     * Getting single Projects by its UID. The project is modeled as a feature in a GeoJSON structure.
     * @param {String} projectUid UID of the project
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {module:api/ProjectsApi~getProjectsByUIDCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/ProjectsEndpointType}
     */
    this.getProjectsByUID = function(projectUid, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'projectUid' is set
      if (projectUid === undefined || projectUid === null) {
        throw new Error("Missing the required parameter 'projectUid' when calling getProjectsByUID");
      }


      var pathParams = {
        'project_uid': projectUid
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = ProjectsEndpointType;

      return this.apiClient.callApi(
        '/projects/{project_uid}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getSpatialSourceByProjectUID operation.
     * @callback module:api/ProjectsApi~getSpatialSourceByProjectUIDCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/SpatialSourcesEndpointType>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Returns the SpatialSources of a Project.
     * Returns the SpatialSources of a Project.
     * @param {String} projectUid Project UID
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Number} opts.page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
     * @param {String} opts.sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
     * @param {Array.<String>} opts.fields Comma separated list of field names
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {module:api/ProjectsApi~getSpatialSourceByProjectUIDCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/SpatialSourcesEndpointType>}
     */
    this.getSpatialSourceByProjectUID = function(projectUid, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'projectUid' is set
      if (projectUid === undefined || projectUid === null) {
        throw new Error("Missing the required parameter 'projectUid' when calling getSpatialSourceByProjectUID");
      }


      var pathParams = {
        'project_uid': projectUid
      };
      var queryParams = {
        'envelope': opts['envelope'],
        'page': opts['page'],
        'sort': opts['sort'],
      };
      var collectionQueryParams = {
        'fields': {
          value: opts['fields'],
          collectionFormat: 'csv'
        },
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [SpatialSourcesEndpointType];

      return this.apiClient.callApi(
        '/projects/{project_uid}/SpatialSources', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the newModelUnderProject operation.
     * @callback module:api/ProjectsApi~newModelUnderProjectCallback
     * @param {String} error Error message, if any.
     * @param {module:model/ProjectsEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create a new model
     * Create a new model.  To add a new Model , the content of Models  must be stored in advanced via the ContentItem endpoint
     * @param {String} projectUid Project UID
     * @param {module:model/ModelsPostRequest} newmodel New model data
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {String} opts.i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
     * @param {module:api/ProjectsApi~newModelUnderProjectCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/ProjectsEndpointType}
     */
    this.newModelUnderProject = function(projectUid, newmodel, opts, callback) {
      opts = opts || {};
      var postBody = newmodel;

      // verify the required parameter 'projectUid' is set
      if (projectUid === undefined || projectUid === null) {
        throw new Error("Missing the required parameter 'projectUid' when calling newModelUnderProject");
      }

      // verify the required parameter 'newmodel' is set
      if (newmodel === undefined || newmodel === null) {
        throw new Error("Missing the required parameter 'newmodel' when calling newModelUnderProject");
      }


      var pathParams = {
        'project_uid': projectUid
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
        'i4l-process-uid': opts['i4lProcessUid']
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = ProjectsEndpointType;

      return this.apiClient.callApi(
        '/projects/{project_uid}/Models', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the newProject operation.
     * @callback module:api/ProjectsApi~newProjectCallback
     * @param {String} error Error message, if any.
     * @param {module:model/ProjectsEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create a new project
     * Create a new project. The new project is modeled as a feature in a GeoJSON structure. Currently only one project feature is allowed.
     * @param {module:model/ProjectsPostRequest} newproject New project data
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {String} opts.i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
     * @param {module:api/ProjectsApi~newProjectCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/ProjectsEndpointType}
     */
    this.newProject = function(newproject, opts, callback) {
      opts = opts || {};
      var postBody = newproject;

      // verify the required parameter 'newproject' is set
      if (newproject === undefined || newproject === null) {
        throw new Error("Missing the required parameter 'newproject' when calling newProject");
      }


      var pathParams = {
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
        'i4l-process-uid': opts['i4lProcessUid']
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = ProjectsEndpointType;

      return this.apiClient.callApi(
        '/projects', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the newSpatialSourceUnderProject operation.
     * @callback module:api/ProjectsApi~newSpatialSourceUnderProjectCallback
     * @param {String} error Error message, if any.
     * @param {module:model/ProjectsEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create a new SpatialSource
     * Create a new SpatialSource. To add a new SpatialSource , the content of SpatialSource  must be stored in advanced via the ContentItem endpoint
     * @param {String} projectUid Project UID
     * @param {module:model/SpatialSourcesPostRequest} newspatialsource New SpatialSource data
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {String} opts.i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
     * @param {module:api/ProjectsApi~newSpatialSourceUnderProjectCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/ProjectsEndpointType}
     */
    this.newSpatialSourceUnderProject = function(projectUid, newspatialsource, opts, callback) {
      opts = opts || {};
      var postBody = newspatialsource;

      // verify the required parameter 'projectUid' is set
      if (projectUid === undefined || projectUid === null) {
        throw new Error("Missing the required parameter 'projectUid' when calling newSpatialSourceUnderProject");
      }

      // verify the required parameter 'newspatialsource' is set
      if (newspatialsource === undefined || newspatialsource === null) {
        throw new Error("Missing the required parameter 'newspatialsource' when calling newSpatialSourceUnderProject");
      }


      var pathParams = {
        'project_uid': projectUid
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
        'i4l-process-uid': opts['i4lProcessUid']
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = ProjectsEndpointType;

      return this.apiClient.callApi(
        '/projects/{project_uid}/SpatialSources', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the updateProjects operation.
     * @callback module:api/ProjectsApi~updateProjectsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/ProjectsEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update a project
     * Updates some attributes of a project.
     * @param {String} projectUid Project UID to be patched
     * @param {module:model/RFC6902PatchRequest} patchproject Update data
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {String} opts.i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
     * @param {module:api/ProjectsApi~updateProjectsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/ProjectsEndpointType}
     */
    this.updateProjects = function(projectUid, patchproject, opts, callback) {
      opts = opts || {};
      var postBody = patchproject;

      // verify the required parameter 'projectUid' is set
      if (projectUid === undefined || projectUid === null) {
        throw new Error("Missing the required parameter 'projectUid' when calling updateProjects");
      }

      // verify the required parameter 'patchproject' is set
      if (patchproject === undefined || patchproject === null) {
        throw new Error("Missing the required parameter 'patchproject' when calling updateProjects");
      }


      var pathParams = {
        'project_uid': projectUid
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
        'i4l-process-uid': opts['i4lProcessUid']
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = ProjectsEndpointType;

      return this.apiClient.callApi(
        '/projects/{project_uid}', 'PATCH',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
