/**
 * its4land Public API
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/TrainingSetsPostRequest', 'model/TrainingsSetEndpointType'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/TrainingSetsPostRequest'), require('../model/TrainingsSetEndpointType'));
  } else {
    // Browser globals (root is window)
    if (!root.Its4landPublicApi) {
      root.Its4landPublicApi = {};
    }
    root.Its4landPublicApi.TrainingSetsApi = factory(root.Its4landPublicApi.ApiClient, root.Its4landPublicApi.TrainingSetsPostRequest, root.Its4landPublicApi.TrainingsSetEndpointType);
  }
}(this, function(ApiClient, TrainingSetsPostRequest, TrainingsSetEndpointType) {
  'use strict';

  /**
   * TrainingSets service.
   * @module api/TrainingSetsApi
   * @version 0.0.2
   */

  /**
   * Constructs a new TrainingSetsApi. 
   * @alias module:api/TrainingSetsApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the getTrainingSetByUID operation.
     * @callback module:api/TrainingSetsApi~getTrainingSetByUIDCallback
     * @param {String} error Error message, if any.
     * @param {module:model/TrainingsSetEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Returns a single TrainingSet
     * Returns a single TrainingSet
     * @param {String} trainingsetsUid TrainingSet UID
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {module:api/TrainingSetsApi~getTrainingSetByUIDCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/TrainingsSetEndpointType}
     */
    this.getTrainingSetByUID = function(trainingsetsUid, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'trainingsetsUid' is set
      if (trainingsetsUid === undefined || trainingsetsUid === null) {
        throw new Error("Missing the required parameter 'trainingsetsUid' when calling getTrainingSetByUID");
      }


      var pathParams = {
        'trainingsets_uid': trainingsetsUid
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = TrainingsSetEndpointType;

      return this.apiClient.callApi(
        '/trainingsets/{trainingsets_uid}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getTrainingSets operation.
     * @callback module:api/TrainingSetsApi~getTrainingSetsCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/TrainingsSetEndpointType>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Returns a list of TrainingSets
     * Returns a list of TrainingSets
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.uid Comma separated list of TrainingSet UID
     * @param {Array.<String>} opts.name Comma separated list of TrainingSet Names
     * @param {Array.<String>} opts.models Comma separated list of model UID
     * @param {Array.<String>} opts.tags Comma separated list of tags
     * @param {Number} opts.page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
     * @param {String} opts.sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
     * @param {Array.<String>} opts.fields Comma separated list of field names
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {module:api/TrainingSetsApi~getTrainingSetsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/TrainingsSetEndpointType>}
     */
    this.getTrainingSets = function(opts, callback) {
      opts = opts || {};
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
        'envelope': opts['envelope'],
        'page': opts['page'],
        'sort': opts['sort'],
      };
      var collectionQueryParams = {
        'uid': {
          value: opts['uid'],
          collectionFormat: 'csv'
        },
        'name': {
          value: opts['name'],
          collectionFormat: 'csv'
        },
        'models': {
          value: opts['models'],
          collectionFormat: 'csv'
        },
        'tags': {
          value: opts['tags'],
          collectionFormat: 'csv'
        },
        'fields': {
          value: opts['fields'],
          collectionFormat: 'csv'
        },
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [TrainingsSetEndpointType];

      return this.apiClient.callApi(
        '/trainingsets', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the newTrainingSet operation.
     * @callback module:api/TrainingSetsApi~newTrainingSetCallback
     * @param {String} error Error message, if any.
     * @param {module:model/TrainingsSetEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create a new TrainingSet
     * Create a new TrainingSet. To add a new TrainingSet , the content of TrainingSet  must be stored in advanced via the ContentItem endpoint
     * @param {module:model/TrainingSetsPostRequest} newtrainingset New TrainingSet data
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {String} opts.i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
     * @param {module:api/TrainingSetsApi~newTrainingSetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/TrainingsSetEndpointType}
     */
    this.newTrainingSet = function(newtrainingset, opts, callback) {
      opts = opts || {};
      var postBody = newtrainingset;

      // verify the required parameter 'newtrainingset' is set
      if (newtrainingset === undefined || newtrainingset === null) {
        throw new Error("Missing the required parameter 'newtrainingset' when calling newTrainingSet");
      }


      var pathParams = {
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
        'i4l-process-uid': opts['i4lProcessUid']
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = TrainingsSetEndpointType;

      return this.apiClient.callApi(
        '/trainingsets', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
