/**
 * its4land Public API
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/ModelsEndpointTypeProjects'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./ModelsEndpointTypeProjects'));
  } else {
    // Browser globals (root is window)
    if (!root.Its4landPublicApi) {
      root.Its4landPublicApi = {};
    }
    root.Its4landPublicApi.DDILayersEndpointType = factory(root.Its4landPublicApi.ApiClient, root.Its4landPublicApi.ModelsEndpointTypeProjects);
  }
}(this, function(ApiClient, ModelsEndpointTypeProjects) {
  'use strict';




  /**
   * The DDILayersEndpointType model module.
   * @module model/DDILayersEndpointType
   * @version 0.0.2
   */

  /**
   * Constructs a new <code>DDILayersEndpointType</code>.
   * @alias module:model/DDILayersEndpointType
   * @class
   */
  var exports = function() {
    var _this = this;











  };

  /**
   * Constructs a <code>DDILayersEndpointType</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/DDILayersEndpointType} obj Optional instance to populate.
   * @return {module:model/DDILayersEndpointType} The populated <code>DDILayersEndpointType</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('UID')) {
        obj['UID'] = ApiClient.convertToType(data['UID'], 'String');
      }
      if (data.hasOwnProperty('Name')) {
        obj['Name'] = ApiClient.convertToType(data['Name'], 'String');
      }
      if (data.hasOwnProperty('Description')) {
        obj['Description'] = ApiClient.convertToType(data['Description'], 'String');
      }
      if (data.hasOwnProperty('LongDescription')) {
        obj['LongDescription'] = ApiClient.convertToType(data['LongDescription'], 'String');
      }
      if (data.hasOwnProperty('ExtDescriptionURL')) {
        obj['ExtDescriptionURL'] = ApiClient.convertToType(data['ExtDescriptionURL'], 'String');
      }
      if (data.hasOwnProperty('Service')) {
        obj['Service'] = ApiClient.convertToType(data['Service'], 'String');
      }
      if (data.hasOwnProperty('EMName')) {
        obj['EMName'] = ApiClient.convertToType(data['EMName'], 'String');
      }
      if (data.hasOwnProperty('ContentItems')) {
        obj['ContentItems'] = ApiClient.convertToType(data['ContentItems'], ['String']);
      }
      if (data.hasOwnProperty('Tags')) {
        obj['Tags'] = ApiClient.convertToType(data['Tags'], ['String']);
      }
      if (data.hasOwnProperty('Projects')) {
        obj['Projects'] = ApiClient.convertToType(data['Projects'], [ModelsEndpointTypeProjects]);
      }
    }
    return obj;
  }

  /**
   * Publish and Share UID (UUID) of the layer
   * @member {String} UID
   */
  exports.prototype['UID'] = undefined;
  /**
   * Layer name. Must be unique
   * @member {String} Name
   */
  exports.prototype['Name'] = undefined;
  /**
   * Free text for description. Only plain text. Max 255 char.
   * @member {String} Description
   */
  exports.prototype['Description'] = undefined;
  /**
   * Text for description. Can contain html. Max 4000 char.
   * @member {String} LongDescription
   */
  exports.prototype['LongDescription'] = undefined;
  /**
   * URL to an external description of the document.
   * @member {String} ExtDescriptionURL
   */
  exports.prototype['ExtDescriptionURL'] = undefined;
  /**
   * Service type of the layer. WFS or WMS
   * @member {String} Service
   */
  exports.prototype['Service'] = undefined;
  /**
   * When the Em repository is uesed, this paramter contains the name of the layer in the EM repository
   * @member {String} EMName
   */
  exports.prototype['EMName'] = undefined;
  /**
   * List of Images (ContenItems. Used for the DDI Service.
   * @member {Array.<String>} ContentItems
   */
  exports.prototype['ContentItems'] = undefined;
  /**
   * Array of tags (strings).
   * @member {Array.<String>} Tags
   */
  exports.prototype['Tags'] = undefined;
  /**
   * Array of Projects (UID).
   * @member {Array.<module:model/ModelsEndpointTypeProjects>} Projects
   */
  exports.prototype['Projects'] = undefined;



  return exports;
}));


