/**
 * its4land Public API
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/ModelsEndpointTypeModelClasses', 'model/ModelsEndpointTypeProjects'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./ModelsEndpointTypeModelClasses'), require('./ModelsEndpointTypeProjects'));
  } else {
    // Browser globals (root is window)
    if (!root.Its4landPublicApi) {
      root.Its4landPublicApi = {};
    }
    root.Its4landPublicApi.ModelsPostRequest = factory(root.Its4landPublicApi.ApiClient, root.Its4landPublicApi.ModelsEndpointTypeModelClasses, root.Its4landPublicApi.ModelsEndpointTypeProjects);
  }
}(this, function(ApiClient, ModelsEndpointTypeModelClasses, ModelsEndpointTypeProjects) {
  'use strict';




  /**
   * The ModelsPostRequest model module.
   * @module model/ModelsPostRequest
   * @version 0.0.2
   */

  /**
   * Constructs a new <code>ModelsPostRequest</code>.
   * @alias module:model/ModelsPostRequest
   * @class
   * @param name {String} Freely chosen name
   * @param description {String} Free text for description. Only plain text.
   */
  var exports = function(name, description) {
    var _this = this;

    _this['Name'] = name;
    _this['Description'] = description;






  };

  /**
   * Constructs a <code>ModelsPostRequest</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/ModelsPostRequest} obj Optional instance to populate.
   * @return {module:model/ModelsPostRequest} The populated <code>ModelsPostRequest</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('Name')) {
        obj['Name'] = ApiClient.convertToType(data['Name'], 'String');
      }
      if (data.hasOwnProperty('Description')) {
        obj['Description'] = ApiClient.convertToType(data['Description'], 'String');
      }
      if (data.hasOwnProperty('TrainingSet')) {
        obj['TrainingSet'] = ApiClient.convertToType(data['TrainingSet'], 'String');
      }
      if (data.hasOwnProperty('Classifier')) {
        obj['Classifier'] = ApiClient.convertToType(data['Classifier'], 'String');
      }
      if (data.hasOwnProperty('Tools')) {
        obj['Tools'] = ApiClient.convertToType(data['Tools'], ['String']);
      }
      if (data.hasOwnProperty('ModelClasses')) {
        obj['ModelClasses'] = ApiClient.convertToType(data['ModelClasses'], [ModelsEndpointTypeModelClasses]);
      }
      if (data.hasOwnProperty('Tags')) {
        obj['Tags'] = ApiClient.convertToType(data['Tags'], ['String']);
      }
      if (data.hasOwnProperty('Projects')) {
        obj['Projects'] = ApiClient.convertToType(data['Projects'], [ModelsEndpointTypeProjects]);
      }
    }
    return obj;
  }

  /**
   * Freely chosen name
   * @member {String} Name
   */
  exports.prototype['Name'] = undefined;
  /**
   * Free text for description. Only plain text.
   * @member {String} Description
   */
  exports.prototype['Description'] = undefined;
  /**
   * TrainingSet of the model (UID)
   * @member {String} TrainingSet
   */
  exports.prototype['TrainingSet'] = undefined;
  /**
   * Classifier UID
   * @member {String} Classifier
   */
  exports.prototype['Classifier'] = undefined;
  /**
   * Comma separated list tool names which can make use of the model.
   * @member {Array.<String>} Tools
   */
  exports.prototype['Tools'] = undefined;
  /**
   * Array of ModelClasses (UID).
   * @member {Array.<module:model/ModelsEndpointTypeModelClasses>} ModelClasses
   */
  exports.prototype['ModelClasses'] = undefined;
  /**
   * Array of tags (strings).
   * @member {Array.<String>} Tags
   */
  exports.prototype['Tags'] = undefined;
  /**
   * Array of Projects (UID).
   * @member {Array.<module:model/ModelsEndpointTypeProjects>} Projects
   */
  exports.prototype['Projects'] = undefined;



  return exports;
}));


