/**
 * its4land Public API
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/ProjectsEndpointTypePropertiesModels', 'model/ProjectsPostRequestPropertiesSpatialSources'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./ProjectsEndpointTypePropertiesModels'), require('./ProjectsPostRequestPropertiesSpatialSources'));
  } else {
    // Browser globals (root is window)
    if (!root.Its4landPublicApi) {
      root.Its4landPublicApi = {};
    }
    root.Its4landPublicApi.ProjectsPatchRequest = factory(root.Its4landPublicApi.ApiClient, root.Its4landPublicApi.ProjectsEndpointTypePropertiesModels, root.Its4landPublicApi.ProjectsPostRequestPropertiesSpatialSources);
  }
}(this, function(ApiClient, ProjectsEndpointTypePropertiesModels, ProjectsPostRequestPropertiesSpatialSources) {
  'use strict';




  /**
   * The ProjectsPatchRequest model module.
   * @module model/ProjectsPatchRequest
   * @version 0.0.2
   */

  /**
   * Constructs a new <code>ProjectsPatchRequest</code>.
   * @alias module:model/ProjectsPatchRequest
   * @class
   */
  var exports = function() {
    var _this = this;








  };

  /**
   * Constructs a <code>ProjectsPatchRequest</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/ProjectsPatchRequest} obj Optional instance to populate.
   * @return {module:model/ProjectsPatchRequest} The populated <code>ProjectsPatchRequest</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('Name')) {
        obj['Name'] = ApiClient.convertToType(data['Name'], 'String');
      }
      if (data.hasOwnProperty('Description')) {
        obj['Description'] = ApiClient.convertToType(data['Description'], 'String');
      }
      if (data.hasOwnProperty('ProjectDir')) {
        obj['ProjectDir'] = ApiClient.convertToType(data['ProjectDir'], 'String');
      }
      if (data.hasOwnProperty('Models')) {
        obj['Models'] = ApiClient.convertToType(data['Models'], [ProjectsEndpointTypePropertiesModels]);
      }
      if (data.hasOwnProperty('SpatialSources')) {
        obj['SpatialSources'] = ApiClient.convertToType(data['SpatialSources'], [ProjectsPostRequestPropertiesSpatialSources]);
      }
      if (data.hasOwnProperty('AOI')) {
        obj['AOI'] = ApiClient.convertToType(data['AOI'], ['String']);
      }
      if (data.hasOwnProperty('Tags')) {
        obj['Tags'] = ApiClient.convertToType(data['Tags'], ['String']);
      }
    }
    return obj;
  }

  /**
   * Freely chosen name
   * @member {String} Name
   */
  exports.prototype['Name'] = undefined;
  /**
   * Free text for description. Only plain text.
   * @member {String} Description
   */
  exports.prototype['Description'] = undefined;
  /**
   * URI to a directory resource. Not clear if needed.
   * @member {String} ProjectDir
   */
  exports.prototype['ProjectDir'] = undefined;
  /**
   * Array of models (UID).
   * @member {Array.<module:model/ProjectsEndpointTypePropertiesModels>} Models
   */
  exports.prototype['Models'] = undefined;
  /**
   * Array of SpatialSources (UID).
   * @member {Array.<module:model/ProjectsPostRequestPropertiesSpatialSources>} SpatialSources
   */
  exports.prototype['SpatialSources'] = undefined;
  /**
   * Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1. Patch requires a complete polygon.
   * @member {Array.<String>} AOI
   */
  exports.prototype['AOI'] = undefined;
  /**
   * Array of tags (strings) of the associated models. Patch requires an updated array.
   * @member {Array.<String>} Tags
   */
  exports.prototype['Tags'] = undefined;



  return exports;
}));


