/**
 * its4land Public API
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/ProjectsEndpointTypeCrs', 'model/ProjectsPostRequestFeatures'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./ProjectsEndpointTypeCrs'), require('./ProjectsPostRequestFeatures'));
  } else {
    // Browser globals (root is window)
    if (!root.Its4landPublicApi) {
      root.Its4landPublicApi = {};
    }
    root.Its4landPublicApi.ProjectsPostRequest = factory(root.Its4landPublicApi.ApiClient, root.Its4landPublicApi.ProjectsEndpointTypeCrs, root.Its4landPublicApi.ProjectsPostRequestFeatures);
  }
}(this, function(ApiClient, ProjectsEndpointTypeCrs, ProjectsPostRequestFeatures) {
  'use strict';




  /**
   * The ProjectsPostRequest model module.
   * @module model/ProjectsPostRequest
   * @version 0.0.2
   */

  /**
   * Constructs a new <code>ProjectsPostRequest</code>.
   * @alias module:model/ProjectsPostRequest
   * @class
   * @param type {module:model/ProjectsPostRequest.TypeEnum} GeoJson feature collection
   * @param name {module:model/ProjectsPostRequest.NameEnum} Name of the feature collection. Always i4lProject
   * @param crs {module:model/ProjectsEndpointTypeCrs} 
   * @param features {Array.<module:model/ProjectsPostRequestFeatures>} 
   */
  var exports = function(type, name, crs, features) {
    var _this = this;

    _this['type'] = type;
    _this['name'] = name;
    _this['crs'] = crs;
    _this['features'] = features;
  };

  /**
   * Constructs a <code>ProjectsPostRequest</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/ProjectsPostRequest} obj Optional instance to populate.
   * @return {module:model/ProjectsPostRequest} The populated <code>ProjectsPostRequest</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('type')) {
        obj['type'] = ApiClient.convertToType(data['type'], 'String');
      }
      if (data.hasOwnProperty('name')) {
        obj['name'] = ApiClient.convertToType(data['name'], 'String');
      }
      if (data.hasOwnProperty('crs')) {
        obj['crs'] = ProjectsEndpointTypeCrs.constructFromObject(data['crs']);
      }
      if (data.hasOwnProperty('features')) {
        obj['features'] = ApiClient.convertToType(data['features'], [ProjectsPostRequestFeatures]);
      }
    }
    return obj;
  }

  /**
   * GeoJson feature collection
   * @member {module:model/ProjectsPostRequest.TypeEnum} type
   */
  exports.prototype['type'] = undefined;
  /**
   * Name of the feature collection. Always i4lProject
   * @member {module:model/ProjectsPostRequest.NameEnum} name
   */
  exports.prototype['name'] = undefined;
  /**
   * @member {module:model/ProjectsEndpointTypeCrs} crs
   */
  exports.prototype['crs'] = undefined;
  /**
   * @member {Array.<module:model/ProjectsPostRequestFeatures>} features
   */
  exports.prototype['features'] = undefined;


  /**
   * Allowed values for the <code>type</code> property.
   * @enum {String}
   * @readonly
   */
  exports.TypeEnum = {
    /**
     * value: "FeatureCollection"
     * @const
     */
    "FeatureCollection": "FeatureCollection"  };

  /**
   * Allowed values for the <code>name</code> property.
   * @enum {String}
   * @readonly
   */
  exports.NameEnum = {
    /**
     * value: "i4lProject"
     * @const
     */
    "i4lProject": "i4lProject"  };


  return exports;
}));


